#ifndef SBPF_H
#define SBPF_H

#include <stdio.h>

typedef struct {
   /* Global Dimensions */
   int N;
   int nb;
   int Nb;
   int blksz;

   /* Matrix data */
   double *matrix;

   /* Local size information */
   int rblks; /* Number of local row indices */
   int cblks; /* Number of local column indices */
   
   /* Column pointer array */
   int *cp;

   /* i_last(p) (last local row index) */
   int ilastp;
} DSBPMatrix;

void DSBPInit( DSBPMatrix *A, int nprow, int npcol, int myrow, int mycol, int N, int nb );

void DSBPDestroy( DSBPMatrix *A );

void DSBPFromFull( DSBPMatrix *B, double *A, int ldA, int nprow, int npcol, int myrow, int mycol, int N, int nb );

void DSBP2Matlab( FILE *fp, DSBPMatrix *A, int nprow, int npcol, int myrow, int mycol );


#endif
